package conditionalEvents
{
	function fxDTSBrick::onPrintEquals(%this,%print,%id)
	{
		%brickPrint = fileBase(getPrintTexture(%this.getPrintID()));
		if(%print $= %brickPrint)
		{
			%this.onConditionPass(%this,%id);
		} else
		{
			%this.onConditionFail(%this, %id);
		}
	}

	function fxDTSBrick::onColorEquals(%this,%color,%id)
	{
		if(%color == %this.getColorID())
		{
			%this.onConditionPass(%this,%id);
		} else
		{
			%this.onConditionFail(%this, %id);
		}
	}

	function fxDTSBrick::onTalkEquals(%this,%message,%id)
	{
		if(%message $= %this.speech)
		{
			%this.onConditionPass(%this,%id);
		} else
		{
			%this.onConditionFail(%this, %id);
		}
		%this.speech = "";
	}

//	function fxDTSBrick::onRelayDirEquals(%this,%dir,%id)
//		{
//			if(%dir == %this.RelayDir)
//			{
//				%this.onConditionPass(%this,%id);
//			} else
//			{
//				%this.onConditionFail(%this, %id);
//			}
//			%this.RelayDir = "";
//	}
//
//	// For some reason these functions cause relays to stop working.  If anyone can fix?
//	function fxDTSBrick::fireRelay(%this)
//	{
//		%this.RelayDir = 0;
//		Parent::fireRelay(%this);
//	}
//
//	function fxDTSBrick::fireRelayNorth(%this){
//		%this.RelayDir = 3;
//		Parent::fireRelayNorth(%this);
//	}
//
//	function fxDTSBrick::fireRelayEast(%this){
//		%this.RelayDir = 4;
//		Parent::fireRelayEast(%this);
//	}
//
//	function fxDTSBrick::fireRelaySouth(%this){
//		%this.RelayDir = 1;
//		Parent::fireRelaySouth(%this);
//	}
//
//	function fxDTSBrick::fireRelayWest(%this){
//		%this.RelayDir = 2;
//		Parent::fireRelayWest(%this);
//	}
//
//	function fxDTSBrick::fireRelayUp(%this){
//		%this.RelayDir = 6;
//		Parent::fireRelayUp(%this);
//	}
//
//	function fxDTSBrick::fireRelayDown(%this){
//		%this.RelayDir = 5;
//		Parent::fireRelayDown(%this);
//	}

	function serverCmdmessageSent(%client, %message)
	{
		parent::serverCmdmessageSent(%client, %message);

		if(!isObject(%client.player) || %client.isSpamming)
		{
			return;
		}

		initContainerRadiusSearch(%client.player.getPosition(), %client.player.getScale(), $TypeMasks::fxBrickObjectType);

		while((%object = containerSearchNext()) !$= 0)
		{
			%object.speech = %message;

			%processed = (processed $= "") ? %processed : %processed SPC %processed;
		}

		initContainerRadiusSearch(vectorAdd(%client.player.getPosition(), "0 0" SPC 2.5 * %client.player.getScale()), %client.player.getScale(), $TypeMasks::fxBrickObjectType);

		while((%object = containerSearchNext()) !$= 0)
		{
			if(strReplace(%processed, %object, "") !$= %processed)
			{
				continue;
			}

			%object.speech = %message;
		}
	}

	function serverCmdteamMessageSent(%client, %message)
	{
		parent::serverCmdteamMessageSent(%client, %message);

		if(!isObject(getMiniGameFromObject(%client)) || !isObject(%client.player))
		{
			return;
		}

		initContainerRadiusSearch(%client.player.getPosition(), %client.player.getScale(), $TypeMasks::fxBrickObjectType);

		while((%object = containerSearchNext()) !$= 0)
		{
			%object.speech = %message;

			%processed = (processed $= "") ? %processed : %processed SPC %processed;
		}

		initContainerRadiusSearch(vectorAdd(%client.player.getPosition(), "0 0" SPC 2.5 * %client.player.getScale()), %client.player.getScale(), $TypeMasks::fxBrickObjectType);

		while((%object = containerSearchNext()) !$= 0)
		{
			if(strReplace(%processed, %object, "") !$= %processed)
			{
				continue;
			}

			%object.speech = %message;
		}
	}

	function fxDTSBrick::onConditionPass(%this, %id)
	{
		if(%id == 2)
		{
			%this.processInputEvent("OnCondition2Pass",%this.client);
			return;
		}
		if(%id == 3)
		{
			%this.processInputEvent("OnCondition3Pass",%this.client);
			return;
		}
		%this.processInputEvent("OnCondition1Pass",%this.client);
	}

	function fxDTSBrick::onConditionFail(%this, %id)
	{
		if(%id == 2)
		{
			%this.processInputEvent("OnCondition2Fail",%this.client);
			return;
		}
		if(%id == 3)
		{
			%this.processInputEvent("OnCondition3Fail",%this.client);
			return;
		}
		%this.processInputEvent("OnCondition1Fail",%this.client);
	}


};
activatePackage(conditionalEvents);

registerInputEvent("fxDTSBrick","onCondition1Pass","Self fxDTSBrick");
registerInputEvent("fxDTSBrick","onCondition1Fail","Self fxDTSBrick");
registerInputEvent("fxDTSBrick","onCondition2Pass","Self fxDTSBrick");
registerInputEvent("fxDTSBrick","onCondition2Fail","Self fxDTSBrick");
registerInputEvent("fxDTSBrick","onCondition3Pass","Self fxDTSBrick");
registerInputEvent("fxDTSBrick","onCondition3Fail","Self fxDTSBrick");

registerOutputEvent("fxDTSBrick", "onPrintEquals", "string 1 50	int 1 3 1", 0);
registerOutputEvent("fxDTSBrick", "onColorEquals", "paintColor 0	int 1 3 1", 0);
registerOutputEvent("fxDTSBrick", "onTalkEquals", "string 50 100	int 1 3 1", 0);
//registerOutputEvent("fxDTSBrick", "onRelayDirEquals", "list None 0 North 1 East 2 South 3 West 4 Up 5 Down 6	int 1 3 1", 0);